<!DOCTYPE html>
<html>

<head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import DataTable Library -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <title>Task 43.70</title>
</head>

<body>
    <div class="container mt-4">
        <h2 class="text-center">Lucky Dice History</h2>
        <div class='row jumbotron p-3 m-0'>
            <div class='col-md-12'>
                <form>
                    <div class="form-row">
                        <h5>Thông tin người chơi</h5>
                    </div>
                    <div class='form-row'>
                        <div class="form-group col-md-4">
                            <label>Username</label>
                            <input type="text" id="user-name" class="form-control bg-secondary text-white" disabled />
                        </div>
                        <div class="form-group col-md-4">
                            <label>First Name</label>
                            <input type="text" id='first-name' class="form-control bg-secondary text-white" disabled />
                        </div>
                        <div class="form-group col-md-4">
                            <label>Last Name</label>
                            <input type="text" id="last-name" class="form-control bg-secondary text-white" disabled />
                        </div>
                    </div>
                </form>
            </div>
        </div>
        <div id="log-result" class="mt-5"></div>
        <div class="mt-5">
            <table id="table-voucher-history" class="table table-bordered table-striped table-hover">
                <thead class="thead-dark">
                    <tr>
                        <th scope='col'>STT</th>
                        <th scope='col'>Mã voucher</th>
                        <th scope='col'>Phần trăm giảm giá</th>
                        <th scope='col'>Ngày tạo</th>
                    </tr>
                </thead>
                <tbody>
                </tbody>
            </table>
        </div>
    </div>
    <script>
        "use strict";

        const baseUrl = "http://203.171.20.210:8080/devcamp-lucky-dice";
        var userNameTest = "ngado20";
        var xmlHttpVoucherHistory = new XMLHttpRequest();
        xmlHttpVoucherHistory.open("GET", baseUrl + "/voucher-history?username=" + userNameTest, true);
        xmlHttpVoucherHistory.send();

        /*** REGION 1 - Global variables ***/
        const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice/";
        var gPlayerInfoObj = {};
        var gVoucherHistoryData = [];
        var gNameCol = ["stt", "maVoucher", "phanTramGiamGia", "ngayTao"];
        const gSTT_COL = 0;
        const gMA_VOUCHER_COL = 1;
        const gPHAN_TRAM_GIAM_GIA_COL = 2;
        const gNGAY_TAO_COL = 3;
        var gVoucherDataTable;

        /*** REGION 2 - Event handlers ***/
        onPageLoading();

        /*** REGION 3 - Functions ***/
        function onPageLoading() {
            catchDataFromURL(window.location.href);
            loadPlayerInfoToForm(gPlayerInfoObj);
            getVoucherHistory(gPlayerInfoObj.userName);
        }

        function catchDataFromURL(currentURL) {
            var url = new URL(currentURL);
            gPlayerInfoObj.userName = url.searchParams.get("user_name");
            gPlayerInfoObj.firstName = url.searchParams.get("first_name");
            gPlayerInfoObj.lastName = url.searchParams.get("last_name");
        }

        function loadPlayerInfoToForm(dataObj) {
            $('#user-name').val(dataObj.userName);
            $('#first-name').val(dataObj.firstName);
            $('#last-name').val(dataObj.lastName);
        }

        function getVoucherHistory(userName) {
            $.ajax({
                url: gBASE_URL + "/voucher-history?username=" + userName,
                type: 'GET',
                dataType: 'json',
                success: function (responseObject) {
                    console.log('responseText >>> ' + JSON.stringify(responseObject));
                    if (responseObject.vouchers.length > 0) {
                        responseObject.vouchers.forEach(function (voucher) {
                            gVoucherHistoryData.push(voucher);
                        });
                        loadDataToVoucherTable(gVoucherHistoryData);
                    }
                },
                error: function (xhr, status, error) {
                    console.log(error);
                }
            });
        }

        function loadDataToVoucherTable(voucherArr) {
            gVoucherDataTable = $('#table-voucher-history').DataTable({
                data: voucherArr,
                columns: [
                    { data: gNameCol[gSTT_COL] },
                    { data: gNameCol[gMA_VOUCHER_COL] },
                    { data: gNameCol[gPHAN_TRAM_GIAM_GIA_COL] },
                    { data: gNameCol[gNGAY_TAO_COL] }
                ],
                columnDefs: [
                    {
                        targets: gSTT_COL,
                        className: "text-center text-primary",
                        render: function (data, type, row, meta) {
                            return meta.row + meta.settings._iDisplayStart + 1;
                        }
                    },
                    {
                        targets: gMA_VOUCHER_COL,
                        className: "text-center text-success"
                    },
                    {
                        targets: gPHAN_TRAM_GIAM_GIA_COL,
                        className: "text-center"
                    },
                    {
                        targets: gNGAY_TAO_COL,
                        className: "text-center"
                    }
                ]
            });
        }
    </script>
</body>

</html>